// PortDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "DesfireTest.h"
#include "PortDlg.h"
#include "dbt.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static void LoadUSBDeviceList(CStringList &Liste)
{
  CString strName;
  Liste.RemoveAll();

  int nMaxSize = 255;
	char * USBNamesBuffer = new char[nMaxSize];
	int nLen = TSHRW_ListAllDeviceNames(USBNamesBuffer,nMaxSize);
  int nStrLen = 0;
  do
  {
    strName = USBNamesBuffer + nStrLen;
    nStrLen += strName.GetLength() + 1;
    if(strName.GetLength() != 0)
      Liste.AddTail(strName);
  }while(strName.GetLength() != 0);
  delete []USBNamesBuffer;
}

static void LoadLANDeviceList(CStringList &Liste)
{
  CString strName;
  Liste.RemoveAll();

  int nMaxSize = 2000;
	char * LANNamesBuffer = new char[nMaxSize];
	int nLen = TSHRW_LanListAllDeviceNames(LANNamesBuffer,nMaxSize);
  int nStrLen = 0;
  do
  {
    strName = LANNamesBuffer + nStrLen;
    nStrLen += strName.GetLength() + 1;
    if(strName.GetLength() != 0)
      Liste.AddTail(strName);
  }while(strName.GetLength() != 0);
  delete []LANNamesBuffer;
}

static void LoadCOMDeviceList(CStringList &Liste)
{
  CString strName;
  Liste.RemoveAll();

  int nMaxSize = 255;
	char * SerialPortNamesBuffer = new char[nMaxSize];
	int nLen = TSHRW_GetAvailablePorts(SerialPortNamesBuffer,nMaxSize);
  int nStrLen = 0;
  do
  {
    strName = SerialPortNamesBuffer + nStrLen;
    nStrLen += strName.GetLength() + 1;
    if(strName.GetLength() != 0)
      Liste.AddTail(strName);
  }while(strName.GetLength() != 0);
  delete []SerialPortNamesBuffer;
}

static void LoadBTDeviceList(CStringList &Liste)
{
  CString strName;
  Liste.RemoveAll();

  int nMaxSize = 255;
	char * BTNamesBuffer = new char[nMaxSize];
	int nLen = TSHRW_BT_ListAllDeviceNames(BTNamesBuffer,nMaxSize);
  int nStrLen = 0;
  do
  {
    strName = BTNamesBuffer + nStrLen;
    nStrLen += strName.GetLength() + 1;
    if(strName.GetLength() != 0)
      Liste.AddTail(strName);
  }while(strName.GetLength() != 0);
  delete []BTNamesBuffer;
}

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CPortDlg 

CPortDlg::CPortDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPortDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPortDlg)
	//}}AFX_DATA_INIT
  m_nBaudrate     = AfxGetApp()->GetProfileInt   ("Port","Baudrate"     , 19200);
  m_strPortName   = AfxGetApp()->GetProfileString("Port","Name"         ,    "");
  m_nTimeout      = AfxGetApp()->GetProfileInt   ("Port","Timeout"      ,  1000);
	m_EthernetAktiv = AfxGetApp()->GetProfileInt   ("Port","EthernetAktiv", FALSE);

  if(m_strPortName.IsEmpty())
  {
    AfxGetApp()->WriteProfileString("Port","Name", m_strPortName = "COM1");
  }

  if(m_strPortName.Find("USB: ") == 0)
  {
    // USB Device, zunchst prfen ob es dieses Device noch gibt
    CString SearchName = m_strPortName.Mid(5);
    LoadUSBDeviceList(m_USBListe);
    if (m_USBListe.IsEmpty())
    {
      m_strPortName = "";
      AfxGetApp()->WriteProfileString("Port","Name", m_strPortName);
      m_bIsUSB = false;
      m_bIsLAN = false;
      m_bIsBluetooth = false;
    }
    else if (!m_USBListe.Find(SearchName))
    {
      m_strPortName = "USB: " + m_USBListe.GetHead();
      AfxGetApp()->WriteProfileString("Port","Name", m_strPortName);
      m_bIsUSB = true; 
      m_bIsLAN = false;
      m_bIsBluetooth = false;
    }
    else
    {
      m_bIsUSB = true; 
      m_bIsLAN = false;
      m_bIsBluetooth = false;
    }
  }
  else if ((m_strPortName.Find("LAN: ") == 0) && (m_EthernetAktiv))
  {
    // LAN Device, zunchst prfen ob es dieses Device noch gibt
    CString SearchName = m_strPortName.Mid(5);
    LoadLANDeviceList(m_LANListe);
    if (m_LANListe.IsEmpty())
    {
      m_strPortName = "";
      AfxGetApp()->WriteProfileString("Port","Name", m_strPortName);
      m_bIsUSB = false;
      m_bIsLAN = false;
      m_bIsBluetooth = false;
    }
    else if (!m_LANListe.Find(SearchName))
    {
      m_strPortName = "LAN: " + m_LANListe.GetHead();
      AfxGetApp()->WriteProfileString("Port","Name", m_strPortName);
      m_bIsUSB = false;
      m_bIsLAN = true;
      m_bIsBluetooth = false;
    }
    else
    {
      m_bIsUSB = false;
      m_bIsLAN = true;
      m_bIsBluetooth = false;
    }
  }
  else if (m_strPortName.Find("Bluetooth: ") == 0)
  {
    CString SearchName = m_strPortName.Mid(11);
    LoadBTDeviceList(m_BTListe);
    if (m_BTListe.IsEmpty())
    {
      m_strPortName = "";
      AfxGetApp()->WriteProfileString("Port","Name", m_strPortName);
      m_bIsUSB = false;
      m_bIsLAN = false;
      m_bIsBluetooth = false;
    }
    else if (!m_BTListe.Find(SearchName))
    {
      m_strPortName = "Bluetooth: " + m_USBListe.GetHead();
      AfxGetApp()->WriteProfileString("Port","Name", m_strPortName);
      m_bIsUSB = false; 
      m_bIsLAN = false;
      m_bIsBluetooth = true;
    }
    else
    {
      m_bIsUSB = false; 
      m_bIsLAN = false;
      m_bIsBluetooth = true;
    }
  }
  else
  {
    m_bIsUSB = false;
    m_bIsLAN = false;
    m_bIsBluetooth = false;
  }
}

bool CPortDlg::IsDeviceAvailable(const CString & Name)
{
  if (Name.Find("LAN: ") == 0)
  {
    CString SearchName = Name.Mid(5);
    CStringList LANListe;
    LoadLANDeviceList(LANListe);
    if (LANListe.IsEmpty())
    {
      return false;
    }
    else if (!LANListe.Find(SearchName))
    {
      return false;
    }
    return true;
  }
  return false;
}

void CPortDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPortDlg)
	DDX_Control(pDX, IDC_STOPBITS, m_StopbitsCtrl);
	DDX_Control(pDX, IDC_PARITY, m_ParityCtrl);
	DDX_Control(pDX, IDC_COMBO_BAUDRATE, m_BaudrateCtrl);
	DDX_Control(pDX, IDC_COM1, m_ListBox);
	DDX_Text(pDX, IDC_TIMEOUT, m_nTimeout);
	DDV_MinMaxUInt(pDX, m_nTimeout, 10, 300000);
	DDX_Check(pDX, IDC_ETHERNET_AKTIV, m_EthernetAktiv);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPortDlg, CDialog)
	//{{AFX_MSG_MAP(CPortDlg)
	ON_LBN_SELCHANGE(IDC_COM1, OnSelchangeCom1)
  ON_MESSAGE(WM_DEVICECHANGE,OnDeviceChange)
	ON_BN_CLICKED(IDC_ETHERNET_AKTIV, OnEthernetAktiv)
	ON_BN_CLICKED(IDC_IP_LISTE, OnIpListe)
	ON_CBN_SELCHANGE(IDC_PARITY, OnSelchangeParity)
	ON_CBN_SELCHANGE(IDC_STOPBITS, OnSelchangeStopbits)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CPortDlg 

void CPortDlg::OnOK() 
{
  if(!UpdateData())
    return;

  if(m_ListBox.GetCurSel() >= 0)
  {
    m_ListBox.GetText(m_ListBox.GetCurSel(),m_strPortName);
    AfxGetApp()->WriteProfileString("Port","Name", m_strPortName);
    if (m_strPortName.Find("USB: ") == 0)
    {
      m_bIsUSB = true;
      m_bIsLAN = false;
      m_bIsBluetooth = false;
    }
    else if (m_strPortName.Find("LAN: ") == 0)
    {
      m_bIsUSB = false;
      m_bIsLAN = true;
      m_bIsBluetooth = false;
    }
    else if (m_strPortName.Find("Bluetooth: ") == 0)
    {
      m_bIsUSB = false;
      m_bIsLAN = false;
      m_bIsBluetooth = true;
    }
    else
    {
      m_bIsUSB = false;
      m_bIsLAN = false;
      m_bIsBluetooth = false;
    }
  }

  m_nBaudrate  = 19200;
  if(m_BaudrateCtrl.GetCurSel() >= 0)
  {
    CString strPortBaudrate;
    m_BaudrateCtrl.GetWindowText(strPortBaudrate);
    m_nBaudrate = atoi(strPortBaudrate);

    switch (m_ParityCtrl.GetCurSel())
    {
      case 0:
        if (m_StopbitsCtrl.GetCurSel() == 1)
          m_nBaudrate += 3;
        break;
      case 1:
        m_nBaudrate += 1;
        break;
      case 2:
        m_nBaudrate += 2;
        break;
    }

  	AfxGetApp()->WriteProfileInt("Port","Baudrate",m_nBaudrate);
  }
  AfxGetApp()->WriteProfileInt("Port","Timeout", m_nTimeout);
  AfxGetApp()->WriteProfileInt("Port","EthernetAktiv" , m_EthernetAktiv);

  CDialog::OnOK();
}

BOOL CPortDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
  CString strBaudrate;
  int Para = (m_nBaudrate%100);
  int Baudrate = m_nBaudrate - Para;
  switch (Para)
  {
    default:
    case 0:
      m_ParityCtrl.SetCurSel(0);
      m_StopbitsCtrl.SetCurSel(0);
      break;
    case 1:
      m_ParityCtrl.SetCurSel(1);
      m_StopbitsCtrl.SetCurSel(0);
      break;
    case 2:
      m_ParityCtrl.SetCurSel(2);
      m_StopbitsCtrl.SetCurSel(0);
      break;
    case 3:
      m_ParityCtrl.SetCurSel(0);
      m_StopbitsCtrl.SetCurSel(1);
      break;
  }
  strBaudrate.Format("%d",Baudrate);
  m_BaudrateCtrl.SetCurSel(m_BaudrateCtrl.FindString(-1,strBaudrate));

  if(m_EthernetAktiv)
  {
    // Liste der LAN Devices laden
    if (m_LANListe.IsEmpty())
      LoadLANDeviceList(m_LANListe);
  }
  else
    m_LANListe.RemoveAll();

  // Liste der BT Devices laden
  if (m_BTListe.IsEmpty())
    LoadBTDeviceList(m_BTListe);

  // Liste der USB Devices laden
  if (m_USBListe.IsEmpty())
    LoadUSBDeviceList(m_USBListe);

  // Liste der Seriellen Devices laden
  if (m_PortListe.IsEmpty())
    LoadCOMDeviceList(m_PortListe);

  POSITION pos = NULL;
  pos = m_PortListe.GetHeadPosition();
  CString strInterfaceName;
  while(pos)
  {
    strInterfaceName = m_PortListe.GetNext(pos);
    if(strInterfaceName.Find("\\\\.\\") == 0)
      strInterfaceName = strInterfaceName.Right(strInterfaceName.GetLength() - 4);
    m_ListBox.AddString(strInterfaceName);
  }
  pos = m_USBListe.GetHeadPosition();
  while(pos)
  {
    strInterfaceName = m_USBListe.GetNext(pos);
    strInterfaceName = "USB: " + strInterfaceName;
    m_ListBox.AddString(strInterfaceName);
  }
  pos = m_LANListe.GetHeadPosition();
  while(pos)
  {
    strInterfaceName = m_LANListe.GetNext(pos);
    strInterfaceName = "LAN: " + strInterfaceName;
    m_ListBox.AddString(strInterfaceName);
  }

  pos = m_BTListe.GetHeadPosition();
  while(pos)
  {
    strInterfaceName = m_BTListe.GetNext(pos);
    strInterfaceName = "Bluetooth: " + strInterfaceName;
    m_ListBox.AddString(strInterfaceName);
  }

  m_ListBox.SelectString(-1,m_strPortName);
  if(m_strPortName.Find("USB: ") == 0)
  {
    m_bIsUSB = true;
    m_bIsLAN = false;
    m_bIsBluetooth = false;
  	m_BaudrateCtrl.EnableWindow(FALSE);
    m_ParityCtrl.EnableWindow(FALSE);
    m_StopbitsCtrl.EnableWindow(FALSE);
  }
  else if (m_strPortName.Find("LAN: ") == 0)
  {
    m_bIsUSB = false;
    m_bIsLAN = true;
    m_bIsBluetooth = false;
  	m_BaudrateCtrl.EnableWindow(FALSE);
    m_ParityCtrl.EnableWindow(FALSE);
    m_StopbitsCtrl.EnableWindow(FALSE);
  }
  else if(m_strPortName.Find("Bluetooth: ") == 0)
  {
    m_bIsUSB = false;
    m_bIsLAN = false;
    m_bIsBluetooth = true;
  	m_BaudrateCtrl.EnableWindow(FALSE);
    m_ParityCtrl.EnableWindow(FALSE);
    m_StopbitsCtrl.EnableWindow(FALSE);
  }
  else
  {
    m_bIsUSB = false;
    m_bIsLAN = false;
    m_bIsBluetooth = false;
  	m_BaudrateCtrl.EnableWindow(TRUE);
    m_ParityCtrl.EnableWindow(TRUE);
    m_StopbitsCtrl.EnableWindow(TRUE);
  }

  GetDlgItem(IDC_IP_LISTE)->ShowWindow(m_EthernetAktiv);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CPortDlg::OnSelchangeCom1() 
{
  if(m_ListBox.GetCurSel() >= 0)
  {
    CString strPortName;
    m_ListBox.GetText(m_ListBox.GetCurSel(),strPortName);
    if (strPortName.Find("USB: ") == 0)
    {
      m_bIsUSB = true;
      m_bIsLAN = false;
      m_bIsBluetooth = false;
  	  m_BaudrateCtrl.EnableWindow(FALSE);
      m_ParityCtrl.EnableWindow(FALSE);
      m_StopbitsCtrl.EnableWindow(FALSE);
    }
    else if (strPortName.Find("LAN: ") == 0)
    {
      m_bIsUSB = false;
      m_bIsLAN = true;
      m_bIsBluetooth = false;
  	  m_BaudrateCtrl.EnableWindow(FALSE);
      m_ParityCtrl.EnableWindow(FALSE);
      m_StopbitsCtrl.EnableWindow(FALSE);
    }
    else if (strPortName.Find("Bluetooth: ") == 0)
    {
      m_bIsUSB = false;
      m_bIsLAN = false;
      m_bIsBluetooth = true;
  	  m_BaudrateCtrl.EnableWindow(FALSE);
      m_ParityCtrl.EnableWindow(FALSE);
      m_StopbitsCtrl.EnableWindow(FALSE);
    }
    else
    {
      m_bIsUSB = false;
      m_bIsLAN = false;
      m_bIsBluetooth = false;
  	  m_BaudrateCtrl.EnableWindow(TRUE);
      m_ParityCtrl.EnableWindow(TRUE);
      m_StopbitsCtrl.EnableWindow(TRUE);
    }
  }
}

static bool bInsideDevChange = false;
BOOL CPortDlg::OnDeviceChange( UINT nEventType, DWORD dwData )
{
  if (bInsideDevChange)
    return 1;
  bInsideDevChange = true;

  if ((nEventType == DBT_DEVICEARRIVAL) || (nEventType == DBT_DEVNODES_CHANGED))
  {
    m_ListBox.ResetContent();

    if (m_EthernetAktiv)
    {
      // Liste der LAN Devices laden
      LoadLANDeviceList(m_LANListe);
    }
    else
      m_LANListe.RemoveAll();

    // Liste der BT Devices laden
    LoadBTDeviceList(m_BTListe);

    // Liste der USB Devices laden
    LoadUSBDeviceList(m_USBListe);

    // Liste der Seriellen Devices laden
    LoadCOMDeviceList(m_PortListe);

    POSITION pos = NULL;
    pos = m_PortListe.GetHeadPosition();
    CString strInterfaceName;
    while(pos)
    {
      strInterfaceName = m_PortListe.GetNext(pos);
      if(strInterfaceName.Find("\\\\.\\") == 0)
        strInterfaceName = strInterfaceName.Right(strInterfaceName.GetLength() - 4);
      m_ListBox.AddString(strInterfaceName);
    }
    pos = m_USBListe.GetHeadPosition();
    while(pos)
    {
      strInterfaceName = m_USBListe.GetNext(pos);
      strInterfaceName = "USB: " + strInterfaceName;
      m_ListBox.AddString(strInterfaceName);
    }
    pos = m_LANListe.GetHeadPosition();
    while(pos)
    {
      strInterfaceName = m_LANListe.GetNext(pos);
      strInterfaceName = "LAN: " + strInterfaceName;
      m_ListBox.AddString(strInterfaceName);
    }

    pos = m_BTListe.GetHeadPosition();
    while(pos)
    {
      strInterfaceName = m_BTListe.GetNext(pos);
      strInterfaceName = "Bluetooth: " + strInterfaceName;
      m_ListBox.AddString(strInterfaceName);
    }

    m_ListBox.SelectString(-1,m_strPortName);
  }
  bInsideDevChange = false;
  return 1;
}

void CPortDlg::OnEthernetAktiv() 
{
	UpdateData(TRUE);
  OnDeviceChange(DBT_DEVICEARRIVAL,0);

  GetDlgItem(IDC_IP_LISTE)->ShowWindow(m_EthernetAktiv);
}

void CPortDlg::OnIpListe() 
{
  if (m_EthernetAktiv)
  {
    CString strName;
    CString strListe;
    CString strTitel;

    strTitel.LoadString(IDS_IP_LISTE);

    int nMaxSize = 2000;
	  char * LANNamesBuffer = new char[nMaxSize];
	  int nLen = TSHRW_LanConfigListDevices(LANNamesBuffer,nMaxSize);
    if (nLen <= 1)
    {
      strListe.LoadString(IDS_KEINE_IP_ADRESSEN);
    }
    else
    {
      int nStrLen = 0;
      do
      {
        strName = LANNamesBuffer + nStrLen;
        nStrLen += strName.GetLength() + 1;
        if(strName.GetLength() != 0)
          strListe += strName + "\r\n";
      }while(strName.GetLength() != 0);
    }
    delete []LANNamesBuffer;

    MessageBox(strListe,strTitel,MB_OK);
  }	
}

void CPortDlg::OnSelchangeParity() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	
}

void CPortDlg::OnSelchangeStopbits() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	
}
