using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace rfid
{
  class GIS_HRW_API
  {
    public const int TSHRW_NO_ERROR                   = 0;

    public const int TSHRW_PORT_OEFFNEN               = 1;
    public const int TSHRW_TIMEOUT_UNGUELTIG          = 2;
    public const int TSHRW_PORTHANDLE_UNGUELTIG       = 3;
    public const int TSHRW_TIMEOUT                    = 4;
    public const int TSHRW_BUFFER_ZU_KLEIN            = 5;
    public const int TSHRW_BUFFERGROESSE_FALSCH       = 6;
    public const int TSHRW_FALSCHE_PARAMETER          = 7;
    public const int TSHRW_KEINE_SENDEDATEN           = 8;
    public const int TSHRW_KEINE_EMPFANGSDATEN        = 9;
    public const int TSHRW_CHECKSUMMENFEHLER          = 10;
    public const int TSHRW_KEINE_KOMMUNIKATION        = 11;
    public const int TSHRW_CHECKBUFFER_LEER           = 12;
    public const int TSHRW_MODE_UNGUELTIG             = 13;
    public const int TSHRW_BEFEHL_NICHT_ERLAUBT       = 14;
    public const int TSHRW_BLOCKNR_UNGUELTIG          = 15;
    public const int TSHRW_KOMMANDOFEHLER             = 16;
    public const int TSHRW_RF_IS_OFF                  = 17;
    
    public const int TSHRW_DC3                        = 19; //0x13
    public const int TSHRW_DC4                        = 20; //0x14
    public const int TSHRW_NACK                       = 21; //0x15
    public const int TSHRW_SYNC                       = 22; //0x16
    public const int TSHRW_ETB                        = 23; //0x17
    public const int TSHRW_CANCEL                     = 24; //0x18
    public const int TSHRW_EM                         = 25; //0x19
    public const int TSHRW_MORE_DATA                  = 32; //0x20
    
    // Error codes Leser
    public const int TSHRW_UNBEKANNTES_KOMMANDO       =            TSHRW_CANCEL;
    public const int TSHRW_DATENANZAHL                =            TSHRW_DC4   ;
    public const int TSHRW_KOLLISION                  =            TSHRW_ETB   ;
    public const int TSHRW_NO_TAG                     =            TSHRW_NACK  ;
    public const int TSHRW_NO_VALUE                   =            TSHRW_DC3   ;
    
    // Error codes Leser                              
    public const int TSHRW_ISO_ERROR_COMMAND_NOT_SUPPORTED      =  0x20;
    public const int TSHRW_ISO_ERROR_COMMAND_NOT_RECOGNIZED     =  0x21;
    public const int TSHRW_ISO_ERROR_COMMANDOPTION_NOT_SUPPORTED=  0x22;
    public const int TSHRW_ISO_ERROR_NO_INFO                    =  0x23;
    public const int TSHRW_ISO_ERROR_BLOCK_NOT_AVAILABLE        =  0x24;
    public const int TSHRW_ISO_ERROR_BLOCK_ALREADY_LOCKED       =  0x25;
    public const int TSHRW_ISO_ERROR_CANT_CHANGE_LOCKED_BLOCK   =  0x26;
    public const int TSHRW_ISO_ERROR_NOT_SUCCESSFULLY_PROGRAMMED=  0x27;
    public const int TSHRW_ISO_ERROR_NOT_SUCCESSFULLY_LOCKED    =  0x28;
    public const int TSHRW_ISO_ERROR_UNKNOWN                    =  0x29;
    public const int TSHRW_ISO_FEHLERLAENGE_NICHT_KORREKT       =  0x2A;
    public const int TSHRW_ISO_UNBEKANNTER_TAG                  =  0x2B;
    public const int TSHRW_ISO_ERROR_FRAMING                    =  0x2C;
    
    // Error codes Desfire
    // Desfire TCL errors, generated by card
    public const int TSHRW_DESFIRE_NO_CHANGES_DONE              =  0x1000C; // "No changes done";
    public const int TSHRW_DESFIRE_OUT_OF_EEPROM_ERROR          =  0x1000E; // "Internal error, insufficient NV-Memory to complete operation";
    public const int TSHRW_DESFIRE_ILLEGAL_COMMAND_CODE         =  0x1001C; // "Command code not supported";
    public const int TSHRW_DESFIRE_INTEGRITY_ERROR              =  0x1001E; // "Integrity error, CRC or MAC does not match data / Padding bytes not valid"
    public const int TSHRW_DESFIRE_NO_SUCH_KEY                  =  0x10040; // "Invalid Key number specified";
    public const int TSHRW_DESFIRE_INVALID_LENGTH               =  0x1007E; // "Internal error, length of Command string invalid";
    public const int TSHRW_DESFIRE_PERMISSION_DENIED            =  0x1009D; // "Current config/status does not allow the requested command";
    public const int TSHRW_DESFIRE_INVALID_PARAMETER_VALUE      =  0x1009E; // "Internal error, value of the parameter invalid";
    public const int TSHRW_DESFIRE_APPLICATION_NOT_FOUND        =  0x100A0; // "Requested AID not present on PICC";
    public const int TSHRW_DESFIRE_APPLICATION_INTEGRITY_ERROR  =  0x100A1; // "Unrecoverable error withing application, application will be disabled";
    public const int TSHRW_DESFIRE_AUTHENTICATION_STATUS_ERROR  =  0x100AE; // "Current authentication status does not allow the requested command";
    public const int TSHRW_DESFIRE_ADDITIONAL_FRAME             =  0x100AF; // "Internal error, additonal data frame is expected to be sent";
    public const int TSHRW_DESFIRE_BOUNDARY_ERROR               =  0x100BE; // "Attempt to read/write data from/to beyond the file's limits";
    public const int TSHRW_DESFIRE_PICC_INTEGRITY_ERROR         =  0x100C1; // "Unrecoverable error in card, card will be disabled";
    public const int TSHRW_DESFIRE_COMMAND_ABORTED              =  0x100CA; // "Previous command was not fully completed. Not all frames were requested or provided by the PCD";
    public const int TSHRW_DESFIRE_PICC_DISABLED_ERROR          =  0x100CD; // "Card was disabled by an unrecoverable error";
    public const int TSHRW_DESFIRE_APPLICATION_COUNT_ERROR      =  0x100CE; // "Max. number of applications reached. Number of applications limited to 28";
    public const int TSHRW_DESFIRE_DUPLICATE_NUMBER_ERROR       =  0x100DE; // "Duplicate application/file number given";
    public const int TSHRW_DESFIRE_EEPROM_ERROR                 =  0x100EE; // "Internal error, EEProm could not be written";
    public const int TSHRW_DESFIRE_FILE_NOT_FOUND               =  0x100F0; // "File not found";
    public const int TSHRW_DESFIRE_FILE_INTEGRITY_ERROR         =  0x100F1; // "Unrecoverable error in file";
    // Desfire errors according to ISO 7816, generated by card                
    public const int TSHRW_DESFIRE_ISO7816_BOUNDARY_ERROR       =  0x16282; // "End of file reached before reading all wished bytes";
    public const int TSHRW_DESFIRE_ISO7816_WRONG_LENGTH         =  0x16700; // "Internal error, wrong length";
    public const int TSHRW_DESFIRE_ISO7816_NO_FILE_ACCESS       =  0x16982; // "File access not allowed";
    public const int TSHRW_DESFIRE_ISO7816_FILE_EMPTY           =  0x16985; // "File empty";
    public const int TSHRW_DESFIRE_ISO7816_WRONG_PARAMETER      =  0x16a86; // "Internal error, wrong parameter P1 and/or P2";
    public const int TSHRW_DESFIRE_ISO7816_WRONG_PARAMETER2     =  0x16a82; // "Internal error, wrong parameter P1 and/or P2";
    public const int TSHRW_DESFIRE_ISO7816_FILE_NOT_FOUND       =  0x16c00; // "File not found";
    public const int TSHRW_DESFIRE_ISO7816_UNKNOWN_ERROR        =  0x16f00; // "No precise diagnostics";
    // SDK specific Desfire errors                                            
    public const int TSHRW_DESFIRE_KEY_LENGTH_NOT_16_BYTES      =  0x10020; // "Key length is not 16 bytes"
    public const int TSHRW_DESFIRE_OLD_KEY_LENGTH_NOT_16_BYTES  =  0x10021; // "Old key length is not 16 bytes"
    public const int TSHRW_DESFIRE_KRYPT_3K3DES_NOT_SUPPORTED   =  0x10022; // "Cryptmethod 3K3DES not supported"
    public const int TSHRW_DESFIRE_AUTHENTICATION_MISSING       =  0x10023; // "Command needs authentication";
    public const int TSHRW_DESFIRE_MAC_DOES_NOT_MATCH_DATA      =  0x10024; // "MAC does not match data"
    public const int TSHRW_DESFIRE_CRC_DOES_NOT_MATCH_DATA      =  0x10025; // "CRC after decryption does not match data"
    public const int TSHRW_DESFIRE_PARAMETER_FIELD_TOO_SMALL    =  0x10026; // "Length of parameter buffer smaller than data"
    public const int TSHRW_DESFIRE_INVALID_PARA_LENGTH          =  0x10027; // "Length of parameter field not valid"
    public const int TSHRW_DESFIRE_NOT_ALLOWED_AFTER_AUTH_ISO   =  0x10028; // "Not allowed after authentification with Authenticate ISO or Authenticate AES"

    // Error codes NFC (Near Field Communication)
    public const int TSHRW_NFC_NO_OR_UNSUPPORTED_TAG              = 0x20001; // "Transponder type is not supported in funktions for NFC"
    public const int TSHRW_NFC_UNSUPPORTED_MIFARE_TAG             = 0x20002; // "This Mifare transponder type is not supported in funktions for NFC"
    public const int TSHRW_NFC_ERROR_TAG_TYPE_NOT_DESFIRE         = 0x20003; // "Transponder is not of type DESFire"
    public const int TSHRW_NFC_NOT_NFC_FORMATTED                  = 0x20004; // "Transponder is not NFC formated"
    public const int TSHRW_NFC_ERR_AT_MIFARE_CLASSIC_AUTHENTICATE = 0x20005; // "Authentication of MifareClassic transponder failed"
    public const int TSHRW_NFC_AUTHENT_DESFIRE_CARD_FAILED        = 0x20006; // "Authentication of DESFire card level failed"
    public const int TSHRW_NFC_AUTHENT_DESFIRE_NFC_APP_FAILED     = 0x20007; // "Authentication of DESFire NFC application level failed"
    public const int TSHRW_NFC_ERROR_AT_CHANGING_SETTINGS         = 0x20008; // "Error at changing settings"
    public const int TSHRW_NFC_ERROR_AT_CHANGING_KEY              = 0x20009; // "Error at changing key"
    public const int TSHRW_NFC_ERROR_AT_ISO15693_BLOCK_LOCKING    = 0x2000A; // "Error at locking of blocks in ISO15693 transponder"
    public const int TSHRW_NFC_ERROR_AT_NFC_FORMATTING            = 0x2000B; // "Error at formating transponder as NFC"
    public const int TSHRW_NFC_ERROR_NEWER_VERSION_NFC            = 0x2000C; // "Error, NFc in transponder has newer version as NFC in SDK"
    public const int TSHRW_NFC_ERROR_OLDER_VERSION_NFC            = 0x2000D; // "Error, NFc in transponder has older version as NFC in SDK"
    public const int TSHRW_NFC_WRITE_PROTECTED                    = 0x2000E; // "Transponder is write protected"
    public const int TSHRW_NFC_NFC_READ_PROTECTED                 = 0x2000F; // "Transponder is NFC read protected"
    public const int TSHRW_NFC_NFC_WRITE_PROTECTED                = 0x20010; // "Transponder is NFC write protected"
    public const int TSHRW_NFC_ERROR_AT_BLOCK_READING             = 0x20011; // "Error at reading of blocks"
    public const int TSHRW_NFC_ERROR_AT_BLOCK_WRITING             = 0x20012; // "Error at writing of blocks"
    public const int TSHRW_NFC_ERROR_AT_FILE_WRITING              = 0x20013; // "Error at writing in DESFire file"
    public const int TSHRW_NFC_NOT_ENOUGH_FREE_TAG_MEMORY         = 0x20014; // "Transponder has not enough free memory for this action"
    public const int TSHRW_NFC_ID_OF_NFC_APP_NOT_FOUND            = 0x20015; // "ID of DESFire NFC application not found"
    public const int TSHRW_NFC_IS_NFC_WITHOUT_DATA                = 0x20016; // "Transponder is NFC formated, but has no user data"
    public const int TSHRW_NFC_ERROR_IN_NFC_DATA                  = 0x20017; // "Error in NFC structure"
    public const int TSHRW_NFC_ERROR_IN_URL                       = 0x20018; // "Error in user data of type URL"
    public const int TSHRW_NFC_ERROR_IN_MIME                      = 0x20019; // "Error in user data of type MIME"
    public const int TSHRW_NFC_ERROR_IN_JSON                      = 0x2001A; // "Error in given JSON-String"
    public const int TSHRW_NFC_UNKNOWN_USER_DATA_TYPE             = 0x2001B; // "Transponder is NFC formated and has userdata of unknown type"
    public const int TSHRW_NFC_USER_DATA_NOT_OF_TYPE_URL          = 0x2001C; // "Transponder has NFC user data but not of type URL"
    public const int TSHRW_NFC_USER_DATA_NOT_OF_TYPE_TEXT         = 0x2001D; // "Transponder has NFC user data but not of type Text"

    public delegate int AutoReadCallback([MarshalAsAttribute(UnmanagedType.LPStr)] string pData, int Len);

    const string dllname = "TS_HRW_SDK64.dll";
    [DllImport(dllname)] public static extern int TSHRW_LibVersion();
    [DllImport(dllname)] public static extern int TSHRW_IsVirtualComInstalled();

    [DllImport(dllname)] public static extern int TSHRW_CountAllDevices();
    [DllImport(dllname)] public static extern int TSHRW_ListAllDeviceNames(SByte[] NamenListe, int nBufferSize);
    [DllImport(dllname)] public static extern int TSHRW_ListAllDeviceNamesEx(SByte[] NamenListe, int nBufferSize);
    [DllImport(dllname)] public static extern int TSHRW_GetAvailablePorts(SByte[] NamenListe, int nBufferSize);

    [DllImport(dllname)] public static extern int TSHRW_LanListAllDeviceNames(SByte[] NamenListe, int nBufferSize);
    [DllImport(dllname)] public static extern int TSHRW_LanConfigListDevices(SByte[] Buffer, int nBufferSize);

    [DllImport(dllname)] public static extern int TSHRW_LanChangeIPAddress(SByte[] OldAddress, SByte[] NewAddress, SByte[] IPMask);

    // Change IP Address and Gateway of LAN device
    [DllImport(dllname)] public static extern int TSHRW_LanChangeIPAddressEx(SByte[] OldAddress, SByte[] NewAddress, SByte[] IPMask, SByte[] GatewayAddress);
    
    // Get IP Address and Gateway of LAN device
    [DllImport(dllname)] public static extern int TSHRW_LanGetIPAddressEx(SByte[] strName, SByte[] Address, SByte[] IPMask, SByte[] GatewayAddress);

    [DllImport(dllname)] public static extern int TSHRW_LanIsDeviceAvailable(SByte[] Address);

    [DllImport(dllname)] public static extern int TSHRW_LanConfigOpen(string strName);
    [DllImport(dllname)] public static extern int TSHRW_LanConfigGet(int nHandle, int RecordNr, Byte[] pData, int Len);
    [DllImport(dllname)] public static extern int TSHRW_LanConfigSet(int nHandle, int RecordNr, Byte[] pData, int Len);
    [DllImport(dllname)] public static extern int TSHRW_LanConfigClose(int nHandle,int Reset);

    [DllImport(dllname)] public static extern int TSHRW_HIDConfigRead(int PortHandle, Byte[] pSendBuf, int SendBufLen,Byte[] pRecvBuf, int RecvBufLen);
    [DllImport(dllname)] public static extern int TSHRW_HIDConfigWrite(int PortHandle, Byte[] pSendBuf, int SendBufLen);

    [DllImport(dllname)] public static extern int TSHRW_BT_SetPin (int PortHandle,SByte[] Pin);
    [DllImport(dllname)] public static extern int TSHRW_BT_GetPin (int PortHandle,SByte[]Pin);
    [DllImport(dllname)] public static extern int TSHRW_BT_SetLocalName(int PortHandle, SByte[] LocalName);
    [DllImport(dllname)] public static extern int TSHRW_BT_GetLocalName(int PortHandle, SByte[]LocalName);
    [DllImport(dllname)] public static extern int TSHRW_BT_GetLocalBTAddr(int PortHandle, SByte[] LocalAddr);
    [DllImport(dllname)] public static extern int TSHRW_BT_SetOperationMode(int PortHandle, int Mode);
    [DllImport(dllname)] public static extern int TSHRW_BT_GetOperationMode(int PortHandle, out int pMode);
    [DllImport(dllname)] public static extern int TSHRW_BT_SetValidPorts(int PortHandle, int Ports);
    [DllImport(dllname)] public static extern int TSHRW_BT_GetValidPorts(int PortHandle, out int pPorts);
    [DllImport(dllname)] public static extern int TSHRW_BT_SetEventFilter(int PortHandle, int Filter);
    [DllImport(dllname)] public static extern int TSHRW_BT_GetEventFilter(int PortHandle, out int pFilter);
    [DllImport(dllname)] public static extern int TSHRW_BT_SetDeviceClass(int PortHandle, int DevClass);
    [DllImport(dllname)] public static extern int TSHRW_BT_ChangeUARTSpeed(int PortHandle, int SpeedIdx);

    [DllImport(dllname)] public static extern int TSHRW_BT_ListAllDeviceNames(SByte[] Buffer, int nBufferSize);
    [DllImport(dllname)] public static extern int TSHRW_BT_Search (int PortHandle, SByte[] DeviceList, int nBufferSize, int Timeout , int ClassFilter);
    [DllImport(dllname)] public static extern int TSHRW_BT_Connect(int PortHandle, SByte[] Device, Byte RemotePortNr, int Timeout);
    [DllImport(dllname)] public static extern int TSHRW_BT_CheckConnection(int PortHandle);
    [DllImport(dllname)] public static extern int TSHRW_BT_Disconnect(int PortHandle);

    [DllImport(dllname)] public static extern int TSHRW_OpenPort(SByte[] Name,int Baudrate,int Timeout);
    [DllImport(dllname)] public static extern int TSHRW_ClosePort(int handle);
    [DllImport(dllname)] public static extern int TSHRW_KeepAppActive(int handle,int bActive);

    [DllImport(dllname)] public static extern int TSHRW_SetReaderAdresse(int handle,int Adresse);

    [DllImport(dllname)] public static extern int TSHRW_StartAutoRead(int handle, int TermChar, AutoReadCallback cbFunction);
    [DllImport(dllname)] public static extern int TSHRW_StopAutoRead(int handle);

    [DllImport(dllname)] public static extern int TSHRW_DeviceVersion(int PortHandle, Byte[] pBuffer, int BufLen);
    [DllImport(dllname)] public static extern int TSHRW_IsProgrammer(int PortHandle);
    [DllImport(dllname)] public static extern int TSHRW_IsReader(int PortHandle);
    [DllImport(dllname)] public static extern int TSHRW_IsUSB(int handle);
    [DllImport(dllname)] public static extern int TSHRW_SetBaudrate(int handle, int Baudrate, int ParityMode);
    [DllImport(dllname)] public static extern int TSHRW_SetReaderMode(int handle,int mode);
    [DllImport(dllname)] public static extern int TSHRW_SetRF(int handle,int OnOff);
    [DllImport(dllname)] public static extern int TSHRW_SetIO(int handle,int Maske, int OutWert);
    [DllImport(dllname)] public static extern int TSHRW_ReadIO(int handle);

    [DllImport(dllname)] public static extern int TSHRW_SetLED(int handle, int red, int green, int yellow);
    [DllImport(dllname)] public static extern int TSHRW_Beep(int handle);

    [DllImport(dllname)] public static extern int TSHRW_GetLastError(int handle);
    [DllImport(dllname)] public static extern int TSHRW_GetLastErrorMessage(int handle, int language, SByte[] pMessageBuffer, int MessageBufferLen);

    [DllImport(dllname)] public static extern int TSHRW_ReadSerialNumber(int handle, Byte[] pSerial, int Buflen);
    [DllImport(dllname)] public static extern int TSHRW_SetConfig(int handle,Byte[] pConfig, int ConfigLen);
    [DllImport(dllname)] public static extern int TSHRW_GetConfig(int handle,Byte[] pConfig, int ConfigLen);
    [DllImport(dllname)] public static extern int TSHRW_SetDefault(int handle);

    [DllImport(dllname)] public static extern int TSHRW_GetActivationContext(int handle, Byte[] pData, int Len);
    [DllImport(dllname)] public static extern int TSHRW_WriteActivationContext(int handle, Byte[] pData, int Len);
    [DllImport(dllname)] public static extern int TSHRW_ReadCounter(int handle, out int pCounter);
    [DllImport(dllname)] public static extern int TSHRW_DecrementCounter(int handle, out int pNewCounter);
    [DllImport(dllname)] public static extern int TSHRW_GetDaysRemain(int handle, out int pDaysRemain);
    [DllImport(dllname)] public static extern int TSHRW_UpdateDaysRemain(int handle, out int pDaysRemain);

    [DllImport(dllname)] public static extern int TSHRW_SetCommunicationMode(int handle, int Mode);

    [DllImport(dllname)] public static extern int TSHRW_RawWrite(int handle,Byte[] pBuffer, int BufLen);
    [DllImport(dllname)] public static extern int TSHRW_RawRead(int handle,Byte[] pBuffer, int BufLen);
    [DllImport(dllname)] public static extern int TSHRW_Transfer(int PortHandle, Byte[] pSendBuf, int SendBufLen,Byte[] pRecvBuf, int RecvBufLen);

    [DllImport(dllname)] public static extern int TSHRW_ReadRegister(int handle, int Register, Byte[]pVal);
    [DllImport(dllname)] public static extern int TSHRW_WriteRegister(int handle, int Register, Byte Val);

    [DllImport(dllname)] public static extern int TSHRW_ReadEEProm(int handle, int StartAdresse, Byte[] pData, int Len);
    [DllImport(dllname)] public static extern int TSHRW_WriteEEProm(int handle, int StartAdresse, Byte[] pData, int Len);

    [DllImport(dllname)] public static extern int TSHRW_ISO_Inventory(int handle,Byte[] pBuffer,int BufLen,int nRequestFlag);
    [DllImport(dllname)] public static extern int TSHRW_ISO_InventoryAFI(int handle,Byte[] pBuffer,int BufLen,int nRequestFlag,int AFI);
    [DllImport(dllname)] public static extern int TSHRW_ISO_GetSystemInfo(int handle,Byte[] pBuffer,int BufLen, Byte[] pUID, int UIDLen,int nRequestFlag);
    [DllImport(dllname)] public static extern int TSHRW_ISO_ReadSingleBlock(int handle,int nBlock,Byte[] pBuffer,int BufLen,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport(dllname)] public static extern int TSHRW_ISO_ReadMultipleBlocks(int handle,int nFirstBlock,int nNumberOfBlocks,Byte[] pBuffer,int BufLen,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport(dllname)] public static extern int TSHRW_ISO_WriteSingleBlock(int handle,int nBlock,Byte[] pBuffer,int BufLen,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport(dllname)] public static extern int TSHRW_ISO_SetAirProtokoll(int handle,int nAirSettings);
    [DllImport(dllname)] public static extern int TSHRW_ISO_GetAirProtokoll(int handle,out int nAirSettings);
    [DllImport(dllname)] public static extern int TSHRW_ISO_GetTagInfo(int handle,Byte[] pUID, int UIDLen,out int BlockAnzahl,out int BytesProBlock,out int MfgCode,int nRequestFlag);
    [DllImport(dllname)] public static extern int TSHRW_ISO_LockBlock(int handle,int nBlock,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport(dllname)] public static extern int TSHRW_ISO_StayQuiet(int handle,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport(dllname)] public static extern int TSHRW_ISO_Select(int handle,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport(dllname)] public static extern int TSHRW_ISO_ResetToReady(int handle,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport(dllname)] public static extern int TSHRW_ISO_GetMultipleBlockSecurityStatus(int handle,int nFirstBlock,int nNumberOfBlocks,Byte[] pBuffer,int BufLen,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport(dllname)] public static extern int TSHRW_ISO_WriteAFI(int handle,int AFI,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport(dllname)] public static extern int TSHRW_ISO_LockAFI(int handle,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport(dllname)] public static extern int TSHRW_ISO_WriteDSFID(int handle,int DSFID,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport(dllname)] public static extern int TSHRW_ISO_LockDSFID(int handle,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport(dllname)] public static extern int TSHRW_ISO_RawRequest(int handle,int nRequestFlag, int nKommando, Byte[] pParam, int nParamLen, Byte[] pData, int nDataLen,Byte[] pReceive, int nReceiveLen);

    [DllImport(dllname)] public static extern int TSHRW_WriteTiming(int handle,int nTiming);
    [DllImport(dllname)] public static extern int TSHRW_SetComparator(int handle,Byte[] pParam, int nParamLen);

    [DllImport(dllname)] public static extern int TSHRW_Mifare_Request(int handle, out ushort pATQA);
    [DllImport(dllname)] public static extern int TSHRW_Mifare_RequestAll(int handle, out ushort pATQA);
    [DllImport(dllname)] public static extern int TSHRW_Mifare_Select(int handle, Byte[] pUID, int nUIDLen, out Byte pSAK);
    [DllImport(dllname)] public static extern int TSHRW_Mifare_SelectUID(int handle, Byte[] pUID, int nUIDLen, out Byte pSAK);
    [DllImport(dllname)] public static extern int TSHRW_Mifare_Halt(int handle);
    [DllImport(dllname)] public static extern int TSHRW_MifareSetKey(int handle, int KeyType, int nAdresse, Byte[] pKey, int nKeyLen);
    [DllImport(dllname)] public static extern int TSHRW_MifareAuthenticate(int handle, Byte[] pUID, int nUIDLen, int KeyType, int nAdresse, int BlockNr);
    [DllImport(dllname)] public static extern int TSHRW_MifareAuthenticateDirect(int handle, Byte[] pUID, int nUIDLen, int KeyType, Byte[] pKey, int nKeyLen, int BlockNr);
    [DllImport(dllname)] public static extern int TSHRW_MifareRead       (int handle, int BlockNr, Byte[] pData, int nDataLen);
    [DllImport(dllname)] public static extern int TSHRW_MifareWrite      (int handle, int BlockNr, Byte[] pData, int nDataLen);
    [DllImport(dllname)] public static extern int TSHRW_MifareGetValue   (int handle, int BlockNr, out int pValue);
    [DllImport(dllname)] public static extern int TSHRW_MifareSetValue   (int handle, int BlockNr, int Value);
    [DllImport(dllname)] public static extern int TSHRW_MifareChangeValue(int handle, int BlockNr, int Richtung, int Differenz);
    [DllImport(dllname)] public static extern int TSHRW_ISO14443SetCID   (int handle, int CID);
    [DllImport(dllname)] public static extern int TSHRW_ISO14443Rats     (int handle, Byte[] pData, int  MaxDataLen);
    [DllImport(dllname)] public static extern int TSHRW_ISO14443PPS      (int handle, int Speed);

    [DllImport("TS_HRW_SDK64..dll")] public static extern int TSHRW_ISO14443B_Transmit(int handle, Byte[] pSendData, int nSendLen, Byte[] pRecvData, int RecvLen);
    [DllImport("TS_HRW_SDK64..dll")] public static extern int TSHRW_ISO14443B_Request (int handle, Byte[] pUID, int UIDLen, Byte[] pAppData, int AppDataLen, Byte[] pProtocolInfo, int ProtocolInfoLen);
    [DllImport("TS_HRW_SDK64..dll")] public static extern int TSHRW_ISO14443B_Wakeup  (int handle, Byte[] pUID, int UIDLen, Byte[] pAppData, int AppDataLen, Byte[] pProtocolInfo, int ProtocolInfoLen);
    [DllImport("TS_HRW_SDK64..dll")] public static extern int TSHRW_ISO14443B_Select  (int handle, int Speed, Byte[] pUID, int UIDLen);

    [DllImport(dllname)] public static extern int TSHRW_ISO14443Transmit (int handle, Byte[] pSendData, int nSendLen, Byte[] pRecvData, int RecvLen);

    [DllImport(dllname)] public static extern int TSHRW_Desfire_GetVersion(int handle, Byte[] pVersionData, int VersionDataLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_GetFreePICCMemory(int handle);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_FormatPICC(int handle);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_GetCardUID(int handle, Byte[] pUID, int UIDBuffLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_SetConfiguration(int handle, Byte Option, Byte[] pSettings, int SettingsLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_Authenticate(int handle, Byte KeyNo, Byte[] pKey, int KeySize);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_AuthenticateIso(int handle, Byte KeyNo, Byte[] pKey, int KeySize);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_AuthenticateAES(int handle, Byte KeyNo, Byte[] pKey, int KeySize);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_GetKeySettings(int handle, Byte[] pKeySettings, int KeySettingsLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_ChangeKeySettings(int handle, Byte ChangeKeyAuthentWith, Byte OtherKeySettings);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_ChangeKey(int handle, Byte KeyNo, Byte[] pNewKey, int NewKeyLen, Byte NewKeyVersion, Byte[] pCurrentKey, int CurrentKeyLen, Byte NewMasterKeyCrypto);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_GetKeyVersion(int handle, Byte KeyNo);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_GetApplicationIdsAndNames(int handle, Byte[] pAppNamesArray, int AppNamesArrayLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_GetApplicationIds(int handle, Byte[] pAppIds, int AppIdsLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_SelectApplication(int handle, int AppId);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_CreateApplication(int handle, int AppId, Byte KeyCrypto, Byte MaxNoOfKeys, int bFilesWithIsoID, Byte ChangeKeyAuthentWith, Byte OtherKeySettings, Byte[] pIso7816Data, int Iso7816DataLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_DeleteApplication(int handle, int AppId);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_GetFileIds(int handle, Byte[] pFileIds, int FileIdsLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_GetFileIsoIds(int handle, Byte[] pFileIds, int FileIdsLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_GetFileSettings(int handle, int FileId, Byte[] pFileSettings, int FileSettingsBufferLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_ChangeFileSettings(int handle, int FileId, int bChangeAccessRightsFree, Byte[] pFileSettings, int FileSettingsLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_CreateStandardDataFile(int handle, Byte FileId, int IsoFileId, int FileSize, Byte CommunicationMode, int AccessRights);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_CreateBackupDataFile(int handle, Byte FileId, int IsoFileId, int FileSize, Byte CommunicationMode, int AccessRights);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_CreateValueFile(int handle, Byte FileId, Byte CommunicationMode, int AccessRights, uint LowerLimit, uint UpperLimit, uint InitialValue, Byte Config);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_CreateLinearRecordFile(int handle, Byte FileId, int IsoFileId, Byte CommunicationMode, int AccessRights, int RecordSize, int MaxCountRecords);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_CreateCyclicRecordFile(int handle, Byte FileId, int IsoFileId, Byte CommunicationMode, int AccessRights, int RecordSize, int MaxCountRecords);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_DeleteFile(int handle, Byte FileId);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_ReadData(int PortHandle, Byte FileId, Byte CommunicationMode, int StartIndex, int ReadCount, Byte[] pReadData, int ReadDataBufferLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_WriteData(int PortHandle, Byte FileId, Byte CommunicationMode, int OffsetInFile, Byte[] pWriteData, int WriteDataLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_GetValue(int handle, Byte FileId, Byte CommunicationMode, out uint pValue);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_Credit(int handle, Byte FileId, Byte CommunicationMode, uint Value);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_LimitedCredit(int handle, Byte FileId, Byte CommunicationMode, uint Value);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_Debit(int handle, Byte FileId, Byte CommunicationMode, uint Value);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_ReadRecord(int PortHandle, Byte FileId, Byte CommunicationMode, int StartRecord, int ReadCountRecords, int RecordSize, Byte[] pReadData, int ReadDataBufferLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_WriteRecord(int PortHandle, Byte FileId, Byte CommunicationMode, int OffsetInRecord, Byte[] pWriteData, int WriteDataLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_ClearRecordFile(int handle, int FileId);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_CommitTransaction(int handle);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_AbortTransaction(int handle);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_IsoSelectApplication(int PortHandle, Byte[] pAppName, int AppNameLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_IsoSelectFile(int PortHandle, int IsoFileId);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_IsoReadData(int PortHandle, int StartIndex, int ReadCount, Byte[] pReadData, int ReadDataBufferLen);
    [DllImport(dllname)] public static extern int TSHRW_Desfire_IsoWriteData(int PortHandle, int StartIndex, Byte[] WriteData, int WriteDataLen);
    [DllImport(dllname)] public static extern int TSHRW_DesfireISO7816EnableWrapping (int PortHandle, int bOn);

    [DllImport(dllname)] public static extern int TSHRW_Nfc_ReadTag(int PortHandle, SByte[] pReadData, int ReadDataBufferLen);
    [DllImport(dllname)] public static extern int TSHRW_Nfc_ReadUrl(int PortHandle, SByte[] pUrl, int UrlLen, SByte[] pText, int TextLen);
    [DllImport(dllname)] public static extern int TSHRW_Nfc_ReadText(int PortHandle, SByte[] pText, int TextLen);
    [DllImport(dllname)] public static extern int TSHRW_Nfc_ReadTagUid(int PortHandle, Byte[] pReadData, int ReadDataLen);
    [DllImport(dllname)] public static extern int TSHRW_Nfc_WriteTag(int PortHandle, SByte[] pWriteData, int WriteDataLen, Byte[] pKey, int Keylen, int Lock);
    [DllImport(dllname)] public static extern int TSHRW_Nfc_WriteUrl(int PortHandle, SByte[] pUrl, int UrlLen, SByte[] pText, int TextLen, Byte[] pKey, int Keylen, int Lock);
    [DllImport(dllname)] public static extern int TSHRW_Nfc_WriteText(int PortHandle, SByte[] pText, int TextLen, Byte[] pKey, int Keylen, int Lock);
    [DllImport(dllname)] public static extern int TSHRW_Nfc_FormatTag(int PortHandle, Byte[] pKey, int Keylen);
    [DllImport(dllname)] public static extern int TSHRW_Nfc_LockTag(int PortHandle, Byte[] pKey, int Keylen);
    [DllImport(dllname)] public static extern int TSHRW_Nfc_SetTagPasswordProtected(int PortHandle, int bUserDataToo, Byte[] pOldKey, int OldKeylen, Byte[] pNewKey, int NewKeylen);

    [DllImport(dllname)] public static extern int TSHRW_WriteParam(int handle,Byte[] pBuffer, int BufLen);
    [DllImport(dllname)] public static extern int TSHRW_ReadParam(int handle,Byte[] pBuffer, int BufLen);
    [DllImport(dllname)] public static extern int TSHRW_WritePrefix(int handle,Byte[] pBuffer, int BufLen);
    [DllImport(dllname)] public static extern int TSHRW_ReadPrefix(int handle,Byte[] pBuffer, int BufLen);
    [DllImport(dllname)] public static extern int TSHRW_WriteSuffix(int handle,Byte[] pBuffer, int BufLen);
    [DllImport(dllname)] public static extern int TSHRW_ReadSuffix(int handle,Byte[] pBuffer, int BufLen);
    [DllImport(dllname)] public static extern int TSHRW_WriteTermix(int handle,Byte[] pBuffer, int BufLen);
    [DllImport(dllname)] public static extern int TSHRW_ReadTermix(int handle,Byte[] pBuffer, int BufLen);
    [DllImport(dllname)] public static extern int TSHRW_WritePostcode(int handle,Byte[] pBuffer, int BufLen);
    [DllImport(dllname)] public static extern int TSHRW_ReadPostcode(int handle,Byte[] pBuffer, int BufLen);
    [DllImport(dllname)] public static extern int TSHRW_WriteReadModeParam(int handle,Byte[] pBuffer, int BufLen);
    [DllImport(dllname)] public static extern int TSHRW_ReadReadModeParam(int handle,Byte[] pBuffer, int BufLen);
    [DllImport(dllname)] public static extern int TSHRW_WriteMifareKey(int handle, int KeyType, Byte[] pKey, int KeyLen);

    public GIS_HRW_API()
    {
    }
  }
}
